<?php
require_once ("op5lic_drvif.php");
class op5lic_drv_unlicensed implements op5lic_drvif {
	private $metrics = array ();
	private $messages = array ();
	public function __construct(op5lic_drv_exception $e) {
		$this->add_message('load', $e->getMessage());
		$params = $e->get_params();
		if (isset($params['messages'])) {
			foreach ($params['messages'] as $context => $messages) {
				foreach ($messages as $message) {
					$this->add_message($context, $message);
				}
			}
		}
		if (isset($params['metrics'])) {
			$this->metrics = $params['metrics'];
		}
	}
	public function query(array $metrics = array(), $cur_time = false) {
		$messages = $this->messages;
		if (!isset($messages['load']))
			$messages['load'] = array ();
		foreach ($metrics as $metric => $query_size) {
			$license_size = 0;
			if (isset($this->metrics[$metric]))
				$license_size = $this->metrics[$metric];
			if ($license_size < $query_size) {
				if (substr($metric, 0, 5) == 'time_') {
					$messages['load'][] = 'Your license expired '.op5lic::format_time_diff($query_size - $license_size).' ago';
				}
			}
		}
		return array ('metrics' => $this->metrics,'messages' => $messages);
	}
	public function fetch_property($prop) {
		$props = array ('enable_extra_license_info' => true,
			'unlicensed' => true);
		if (isset($props[$prop]))
			return $props[$prop];
		return false;
	}
	public function fetch_customer_info() {
		return array ();
	}

	/**
	 * Add a message to a given context or contexts.
	 *
	 * @param $context string
	 *        	A list of contexts, or a string containing a space separated
	 *        	list of contexts
	 * @param $message string
	 *        	The message.
	 */
	public function add_message($contexts, $message) {
		if (!is_array($contexts)) {
			$contexts = explode(' ', $contexts);
		}
		foreach ($contexts as $ctx) {
			if (!isset($this->messages[$ctx])) {
				$this->messages[$ctx] = array ();
			}
			$this->messages[$ctx][] = $message;
		}
	}
}
